#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>


#define SCREEN_WIDTH 128 // szerokość w pikselach
#define SCREEN_HEIGHT 64 // wysokość w pikselach
// tworzymy  obiekt wyświetlacza o nazwie: wysw
Adafruit_SSD1306 wysw(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);
int scrollSpeed = 30;
int spacer = 1;
int width = 5 + spacer;

void setup() { // jednorazowo w funkcji setup():
  Serial.begin(9600);
// inicjalizacja obiektu wysw
  if(!wysw.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // adres 0x3C
    Serial.println(F("brak kontaktu z modulem OLED!"));
    for(;;); } //nic nie rób, jeśli brak kontaktu
 
  // pokaż ekran powitalny - logo Adafruit przez 2 sekundy:
  wysw.display();   delay(2000); 
  wysw.clearDisplay(); } //wyczyść ekran

void loop() {
  wysw.drawPixel(1, 1, HIGH);  wysw.display(); delay(1000);
  wysw.drawPixel(16, 5, HIGH); wysw.display(); delay(1000);
  wysw.drawPixel(16, 5, LOW); wysw.display(); delay(300);
  wysw.drawPixel(16, 5, HIGH); wysw.display(); delay(300);
  wysw.drawPixel(16, 5, LOW); wysw.display(); delay(300);
  wysw.drawPixel(16, 5, HIGH); wysw.display(); delay(300);
  wysw.drawPixel(16, 5, LOW); wysw.display(); delay(300);
  wysw.drawPixel(16, 5, HIGH); wysw.display(); delay(1000);
  wysw.drawCircle(10, 4, 3, 1); wysw.display(); delay(1000);
  wysw.fillCircle(19, 3, 3, 1); wysw.display(); delay(1000);
  wysw.drawPixel(19, 4, LOW); wysw.display(); delay(300);
  wysw.drawPixel(19, 4, HIGH); wysw.display(); delay(300);
  wysw.drawPixel(19, 4, LOW); wysw.display(); delay(300);
  wysw.drawPixel(19, 4, HIGH); wysw.display(); delay(300);
  wysw.drawPixel(19, 4, LOW); wysw.display(); delay(300);
  wysw.drawLine(0, 0, 31, 7, HIGH); wysw.display(); delay(1000);
  wysw.drawFastVLine(27, 0, 8, 1); wysw.display(); delay(1000);
  wysw.drawFastHLine(1, 4, 30, 1); wysw.display(); delay(1000);
  wysw.drawRect(2, 2, 29, 5, HIGH); wysw.display(); delay(2000);
  wysw.fillRect(2, 0, 17, 8, LOW); wysw.display(); delay(1000);
  wysw.drawTriangle(3, 0, 3, 7, 7, 4, 1); wysw.display(); delay(500);
  wysw.fillTriangle(12, 0, 10, 7, 18, 3, 1); wysw.display(); delay(2000);
  wysw.fillRect(7, 0, 26, 7, LOW); wysw.display(); delay(2000);
  wysw.drawChar(8, 0, 'E', 1, 0, 1); wysw.display(); delay(1000);
  wysw.drawChar(14, 0, 'd', 1, 0, 1); wysw.display(); delay(1000);
  wysw.drawChar(20, 0, 'W', 1, 0, 1); wysw.display(); delay(3000);
  wysw.fillScreen(HIGH); wysw.display();   delay(1000);
  wysw.fillScreen(LOW); wysw.display();   delay(1000);
  wysw.fillScreen(LOW); wysw.display();

  wysw.setCursor(0, -3);
  wysw.setTextColor(1, 0);
  wysw.setTextSize(1);
  wysw.setTextWrap(1);
  wysw.print("napis długi do wyswietlenia"); wysw.display();   delay(2000);

  String tekscik = "Tekst, ktory mozesz uzupelnic za pomoca Monitora portu szeregowego: ";
  long int time = millis();
  while (Serial.available()) { tekscik += char(Serial.read());  }
  for (int i = 0; i < width * tekscik.length() + wysw.width() - 1 - spacer; i++ ) {
    wysw.fillScreen(LOW);
    int letter = i / width;
    int x = (wysw.width() - 1) - i % width;
    int y = (wysw.height() - 8) / 2;

    while (x + width - spacer >= 0 && letter >= 0) {
      if (letter < tekscik.length()) {
        wysw.drawChar(x, y, tekscik[letter], HIGH, LOW, 1);

      }
      letter--;
      x -= width;
    }
    wysw.display();
    delay(scrollSpeed);
  }
}
